/*
   +----------------------------------------------------------------------+
   | PHP Version 7                                                        |
   +----------------------------------------------------------------------+
   | Copyright (c) 1997-2018 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Author: Jim Winstead <jimw@php.net>                                  |
   +----------------------------------------------------------------------+
 */

#ifndef URL_H
#define URL_H

#ifdef __cplusplus
extern "C"
{
#endif

void url_encode(char const *s, size_t len, char *out, size_t *out_len);
void url_decode(char *str, size_t len, char *out, size_t *out_len); /* return value: length of decoded string */
void raw_url_encode(char const *s, size_t len, char *out, size_t *out_len);
void raw_url_decode(char *str, size_t len, char *out, size_t *out_len); /* return value: length of decoded string */
char *replace_controlchars_ex(char *str, size_t len);

#define PHP_QUERY_RFC1738 1
#define PHP_QUERY_RFC3986 2

#ifdef __cplusplus
}
#endif

#endif /* URL_H */

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
